       Integer Function PrintLogFile (unit,logfile, FileName)
C==============================================================
C 
C
C
      IMPLICIT None
C
C Declare Character Type Variables ...
C
      Character 
     > ProgramName*20,        !Name of Program that wrote to log
     > Message*80,            !Message logged
     > SetLogFileName*30,     !Name of function
     > DateTime*16,           !Time And Date on log file
     > LogName*30,            !name of function at has log name
     > DefaultName*11,        !Default file name for output
     > FileRemove*17          !Command Sent to system 
C 
      Character*(*) 
     > FileName,              !file name entered by user.
     > logfile                ! Name of log file to be printed.
C
C Declare Integer Type Variables...
C
      Integer 
C     >   PrintLogFile,          !Name of Function
     >   MaximumRecords,        !Maximum Records being logged
     >   ios,                   !Error status on file open
     >   unit,                  !Random Access file unit
     >   CurrentRecord,         !Next Available record to write
     >   RecordCount,           !Number of records writen
     >   count,                 !Counter for Loops
     >   valid,                 !Length of input file entered
     >   valid2,
     >   unit_out,              !Where the output will go.
     >   record_out             !record to be printed.
C
C Declare Logical Type Variables
C
      Logical 
     >  THERE                     !The Existance of a file on disk
C
C
C Setup Local Variables Data Statements.....
C
      unit_out = unit + 1
      valid = LEN(FileName)
      valid2 = LEN(logfile)
      LogName = SetLogFileName(unit, 'x')
      Data DefaultName/'APVSLog.txt'/
      FileRemove = 'rm '//DefaultName
C

C
C Change name of log file if valid logfile name is entered
C
      if (valid2 .GT. 5) then
          LogName = SetLogFileName(unit, logfile)
      endif
C

C Check to see if there is a log file to be printed...

      INQUIRE (FILE=LogName, EXIST=THERE)
C
C
C If there was no log file to print print error messsage..
C Set PrintLogFile to indecate there was an error and return..
C
        if  (.NOT. THERE)  then
            WRITE(6,*) 'Error: Log file in not on Disk'
            PrintLogFile = -1
            Return
        END IF
C
C
C Open log file....
C
      OPEN (UNIT=unit, 
     >      FILE=LogName, 
     >      ACCESS="DIRECT", 
     >      RECL=500,
C     >      RECL=125,
     >      IOSTAT=ios, 
     >      STATUS="OLD",
     >      FORM="UNFORMATTED")
C
C
C Read Header record from Random Access File....
C
      READ (UNIT=unit, REC=1) 
     >      MaximumRecords, 
     >      CurrentRecord, 
     >      RecordCount
C
C Check to see If ther are any records to print....
C If record count equals Zero...No records  writen
C to log file. Print error message set PrintLogFile to 
C indacate an error and return. 
C
      if (RecordCount .EQ. 0) then
          WRITE(6,*) 'ERROR: There are no file to Print'
          PrintLogFile = -1
          Return
      END IF
C
C
C Check the existanc of the file name entered by the user ....
C
      INQUIRE (FILE=FileName, EXIST=THERE)

        if ((.NOT. THERE).AND. (valid .GT. 1)) then
            OPEN (UNIT=unit_out,
     >            FILE=FileName, 
     >            ACCESS='SEQUENTIAL',
     >            IOSTAT=ios,
     >            STATUS="NEW",
     >            FORM='FORMATTED')
       else
C
           INQUIRE (FILE=DefaultName, EXIST=THERE)
           if (THERE) call syscall(FileRemove)
           OPEN (UNIT=unit_out,
     >           FILE=DefaultName, 
     >           ACCESS='SEQUENTIAL',
     >           IOSTAT=ios,
     >           STATUS="NEW",
     >           FORM='FORMATTED')
      end if
C
C
C
C
C Set record_out to the last record that was written to the
C log file.  CurrentRecord is th next record to be written. 
C
        IF (RecordCount .EQ. MaximumRecords) then
            record_out = CurrentRecord
        else
            record_out = 2
        end if
C
C Loop through the Random Access file the total number of 
C records written to the file.  
C
      DO 10 count = RecordCount, 1, -1
C Check to make sure the Header Record is not printed 
C
        if (record_out .GT. MaximumRecords + 1) then
            record_out = 2
        end if
C
C Read in the Record form the Random Access File and 
C Write that record to the Sequentaial file.
C
        READ(UNIT=unit, REC=record_out) 
     >       DateTime, 
     >       ProgramName, 
     >       Message
        WRITE(unit_out, 100) 
     >        DateTime, 
     >        ProgramName, 
     >        Message
100     FORMAT(1X, A16, T25, A20, T50, A80)
        record_out = record_out + 1

10      continue

C Close all the files ...
C
        close(unit_out)
        close (unit)
      

      END
