C
C 07 Sep 2001   Now call function FRMT for band 5 processing, just like
C               bands 2-4 (FRMT was excluded from band 5 processing before,
C               for some reason...)
C
C ---------------------------------------------------------- 
C [ CHECKS THE IR COEFFICIENTS IN THE CODICIL WITH THOSE   [ 
C [ SET AT THE FACTORY TO SEE IF THEY HAVE CHANGED.  IF    [ 
C [ ANY HAVE CHANGED AN EDEST MESSAGE IS DISPLAY SAYING SO.[ 
C [ IF COEFF HAVE CHANGED THEN NEW COEFF ARE RETURNED FOR  [ 
C [ USE.  ELSE FACTORY VALUES ARE RETURNED                 [ 
C [ RECEIVES: ISAT - SATELLITE NUMBER                      [ 
C [           IBAND - BAND NUMBER                          [ 
C [           CODARR - CODICIL ARRAY                       [ 
C [ RETURNS:  GAIN - GAIN SCALING FACTOR FOR THIS BAND     [ 
C [           BIAS - BIAS SCALING FACTOR FOR THIS BAND     [ 
C ---------------------------------------------------------- 
Ctn!       SUBROUTINE CHKIR_IM(ISAT, IBAND, CODARR, 
Ctn!     * GAIN, BIAS, HVCOD)
       SUBROUTINE CHKIR_IM(ISAT, IBAND, CODARR, 
     * GAIN, BIAS, HVCOD,CSAT)

       INTEGER ISAT, IBAND, CODARR(128), HVCOD, KBUG
       INTEGER IFLAG_GAIN, IFLAG_BIAS 
       INTEGER SBIASOFF, SGAINOFF
       INTEGER LOC2, LOC3, LOC4, LOC5      ! calibration codicil offsets to gain and bias scaling coefficients

       REAL GAIN, BIAS, MXDF, FRMT 
       REAL IIRGAIN(4), IIRBIAS(4), SIRGAIN(18), SIRBIAS(18) 
  
Ctn! Declare CSAT
       CHARACTER*1 CSAT
       CHARACTER*12 CFG
       CHARACTER*15 PN

       COMMON/DBUG/KBUG
C  
C      OFFSETS TO THE BIAS AND GAIN VALUES IN IMAGER CODICIL 
C
       DATA IBIASOFF /25/, IGAINOFF /33/ 
C  
C      OFFSETS TO THE BIAS AND GAIN VALUES IN SOUNDER CODICIL 
C
       DATA SBIASOFF /13/, SGAINOFF /31/ 
C  
C      FACTORY GAIN AND BIAS SCALING FACTORS FOR THE IMAGER 
C
       DATA IIRGAIN/  0.522850E+01,  0.502714E+01,  0.227389E+03, 
     *                0.388383E+02/ 
       DATA IIRBIAS/  0.156854E+02,  0.153332E+02,  0.682167E+02, 
     *                0.291287E+02/ 
C  
C      FACTORY GAIN AND BIAS SCALING FACTORS FOR THE SOUNDER 
C
       DATA SIRGAIN/  0.528977E+03,  0.540005E+03,  0.485624E+03, 
     *                0.394575E+03,  0.357802E+03,  0.334175E+03, 
     *                0.311523E+03,  0.314603E+03,  0.434352E+03, 
     *                0.112622E+04,  0.189956E+04,  0.287434E+04, 
     *                0.964275E+04,  0.141054E+05,  0.262213E+05, 
     *                0.107206E+05,  0.121361E+05,  0.193581E+05/ 
       DATA SIRBIAS/  0.174563E+04,  0.156601E+04,  0.131119E+04, 
     *                0.887794E+03,  0.787164E+03,  0.417719E+03, 
     *                0.249218E+03,  0.251683E+03,  0.716680E+03, 
     *                0.900979E+03,  0.113974E+04,  0.215576E+04, 
     *                0.626779E+03,  0.916850E+03,  0.170439E+04, 
     *                0.428824E+03,  0.497581E+03,  0.348446E+03/ 
C  
C      MAXIMUM PERCENT DIFFERENCE THRESHOLD 
C
       DATA MXDF /1.000000E-03/ 
  
       DATA PN/'(CHKIR_IM.FOR)'/

       IFLAG_GAIN = 0 
       IFLAG_BIAS = 0 
  
       IF(MOD(ISAT,2) .EQ. 0) THEN 
C
C ----    EVEN-NUMBERED SSEC SATELLITE NUMBER: CHECK *IMAGER* IR COEFFICIENTS 
C
C         FIRST, ESTABLISH SECONDARY CALIBRATION CODICIL OFFSETS THAT NEED TO BE ADDED
C         TO THE PRIMARY IMAGER BIAS SCALING FACTOR (IBIASOFF) AND THE GAIN SCALING FACTOR (IGAINOFF).
C         THESE SECONDARY OFFSETS CHANGE STARTING WITH GOES-12.  For further information,
C         see the documentation on the GVAR Imager Calibration block in Chapter 7 of the 
C         McIDAS-X Programmer's Manual.
C
Ctn! Use csat for any SATID  (GOES-N.... changed!)
Ctn!          IF(ISAT.LT.78) THEN         ! GOES-8 through GOES-11
          IF(CSAT.EQ.'W') THEN         ! GOES-8 through GOES-11
C changed by TN -1/20/2012
C             LOC2=3               ! Imager channel 2 secondary offset = 3 
C             LOC3=4               ! Imager channel 3 secondary offset = 4
C             LOC4=1               ! Imager channel 4 secondary offset = 1
C             LOC5=2               ! Imager channel 5 secondary offset = 2
             LOC2=1               ! Imager channel 2 secondary offset = 1
             LOC3=2               !                3                    2
             LOC4=3               !                4                    3
             LOC5=4               !                5                    4
          ELSE IF (CSAT.EQ.'E') THEN   !  GOES-12 onward
             LOC2=1               ! Imager channel 2 secondary offset = 1
             LOC3=2               !                3                    2
             LOC4=3               !                4                    3
             LOC5=4               !                5                    4
          ENDIF

          IF(IBAND .EQ. 2) THEN 
C
C-----       CHECK CODICIL GAIN AND BIAS AGAINST FACTORY FOR BAND 2 
C
             BIAS = IIRBIAS(3) 
             GAIN = IIRGAIN(3) 
             IF(PCTDIF(BIAS, FRMT(CODARR(IBIASOFF + LOC2))) .GT. MXDF
     *       .AND. HVCOD .EQ. 1) THEN 
                IFLAG_BIAS = 1 
                BIAS = FRMT(CODARR(IBIASOFF + LOC2)) 
             ENDIF 
             IF(PCTDIF(GAIN, FRMT(CODARR(IGAINOFF + LOC2))) .GT. MXDF
     *       .AND. HVCOD .EQ. 1) THEN 
                IFLAG_GAIN = 1 
                GAIN = FRMT(CODARR(IGAINOFF + LOC2)) 
             ENDIF 
          ENDIF 

          IF(IBAND .EQ. 3) THEN 
C
C-----       CHECK CODICIL GAIN AND BIAS AGAINST FACTORY FOR BAND 3 
C
             BIAS = IIRBIAS(4) 
             GAIN = IIRGAIN(4) 
             IF(PCTDIF(BIAS, FRMT(CODARR(IBIASOFF + LOC3))) .GT. MXDF
     *       .AND. HVCOD .EQ. 1) THEN 
                IFLAG_BIAS = 1 
                BIAS = FRMT(CODARR(IBIASOFF + LOC3)) 
             ENDIF 
             IF(PCTDIF(GAIN, FRMT(CODARR(IGAINOFF + LOC3))) .GT. MXDF
     *       .AND. HVCOD .EQ. 1) THEN 
                IFLAG_GAIN = 1 
                GAIN = FRMT(CODARR(IGAINOFF + LOC3)) 
             ENDIF 
          ENDIF 

          IF(IBAND .EQ. 4) THEN 
C
C-----       CHECK CODICIL GAIN AND BIAS AGAINST FACTORY FOR BAND 4 
C
             BIAS = IIRBIAS(1) 
             GAIN = IIRGAIN(1) 
             IF(PCTDIF(BIAS, FRMT(CODARR(IBIASOFF + LOC4))) .GT. MXDF
     *       .AND. HVCOD .EQ. 1) THEN 
                IFLAG_BIAS = 1 
                BIAS = FRMT(CODARR(IBIASOFF + LOC4)) 
             ENDIF 
             IF(PCTDIF(GAIN, FRMT(CODARR(IGAINOFF + LOC4))) .GT. MXDF
     *       .AND. HVCOD .EQ. 1) THEN 
                IFLAG_GAIN = 1 
                GAIN = FRMT(CODARR(IGAINOFF + LOC4)) 
             ENDIF 
          ENDIF 

          IF(IBAND .EQ. 5) THEN 
C  
C-----       CHECK CODICIL GAIN AND BIAS AGAINST FACTORY FOR BAND 5 
C
             BIAS = IIRBIAS(2) 
             GAIN = IIRGAIN(2) 
             IF(PCTDIF(BIAS, FRMT(CODARR(IBIASOFF + LOC5))) .GT. MXDF
     *       .AND. HVCOD .EQ. 1) THEN 
                IFLAG_BIAS = 1 
                BIAS = FRMT(CODARR(IBIASOFF + LOC5))
             ENDIF 
             IF(PCTDIF(GAIN, FRMT(CODARR(IGAINOFF + LOC5))) .GT. MXDF
     *       .AND. HVCOD .EQ. 1) THEN 
                IFLAG_GAIN = 1 
                GAIN = FRMT(CODARR(IGAINOFF + LOC5))
             ENDIF 
          ENDIF 
       ENDIF 
  
       IF(MOD(ISAT,2) .EQ. 1) THEN 
C
C ----    ODD-NUMBERED SSEC SATELLITE NUMBER: CHECK *SOUNDER* IR COEFFICIENTS 
C
C ---     CHECK SOUNDER IR GAIN FACTORS 
C
          IF(PCTDIF(SIRGAIN(IBAND), FRMT(CODARR(SGAINOFF + IBAND))) 
     *    .GT. MXDF .AND. HVCOD .EQ. 1) THEN 
             IFLAG_GAIN = 1 
             GAIN = FRMT(CODARR(SGAINOFF + IBAND)) 
          ELSE 
             GAIN = SIRGAIN(IBAND) 
          ENDIF 
C
C ---     CHECK SOUNDER IR BIAS FACTORS 
C
          IF(PCTDIF(SIRBIAS(IBAND), FRMT(CODARR(SBIASOFF + IBAND))) 
     *    .GT. MXDF .AND. HVCOD .EQ. 1) THEN 
             IFLAG_BIAS = 1 
             BIAS = FRMT(CODARR(SBIASOFF + IBAND)) 
          ELSE 
             BIAS = SIRBIAS(IBAND) 
          ENDIF 
       ENDIF 
  
C ---  CHECK IF ANY ERROR FLAGS HAVE BEEN SET 
  
       IF(IFLAG_GAIN .GT. 0 .AND. HVCOD .EQ. 1) THEN 
          CALL DDEST('IR GAIN SCALING CALIBRATION COEFFICIENT '//
     *    'CHANGED-- USING CURRENT VALUE FROM AREA CAL...', 0) 
          IF(KBUG.GT.10) THEN
             CALL SDEST(PN//'IR GAIN SCALING CALIBRATION '//
     *       'COEFFICIENT CHANGED-- USING CURRENT VALUE '//
     *       'FROM AREA CAL...',0) 
          ENDIF
       ENDIF 
  
       IF(IFLAG_BIAS .GT. 0 .AND. HVCOD .EQ. 1) THEN 
          CALL DDEST('IR BIAS SCALING CALIBRATION COEFFICIENT '//
     *    'CHANGED-- USING CURRENT VALUE FROM AREA CAL...', 0) 
          IF(KBUG.GT.10) THEN
             CALL SDEST(PN//'IR BIAS SCALING CALIBRATION '//
     *       'COEFFICIENT CHANGED-- USING CURRENT VALUE '//
     *       'FROM AREA CAL...',0) 
          ENDIF
       ENDIF 

       IF(HVCOD .EQ. 0) THEN
          CALL DDEST('NO AREA CALIBRATION CODICIL: USING DEFAULT'//
     *    ' GAIN & BIAS SCALING CALIBRATION FACTORS...', 0)
          IF(KBUG.GT.10) THEN
             CALL SDEST(PN//'NO AREA CALIBRATION CODICIL: '//
     *       'USING DEFAULT GAIN & BIAS SCALING CALIBRATION '//
     *       'FACTORS...',0) 
          ENDIF
       ENDIF

       RETURN 
       END 
