C ----------------------------------------------------------- 
C [ COMPARES THE FACTORY VISIBLE COEFFICIENTS TO THOSE OF   [ 
C [ THE CODICIL SENT WITH THIS IMAGE.  IF THEY ARE DIFFERENT[ 
C [ THEN A WARNING MESSAGE IS DISPLAYED AND THE NEW COEFF   [ 
C [ ARE RETURNED IN THE ARRAY VISARR.                       [ 
C [                                                         [ 
C [ RECEIVES: INTEGER ISAT - SATELLITE NUMBER               [ 
C [           INTEGER CODARR - CODICIL ARRAY                [ 
C [ RETURNS:  REAL VISARR - ARRAY OF VISIBLE CALIBRATION    [ 
C ----------------------------------------------------------- 
       SUBROUTINE CHKVIS_IM(ISAT, CODARR, VISARR, HVCOD) 
  
       IMPLICIT INTEGER(A-Z) 

       INTEGER ISAT, CODARR(128), NEWPOS, CODPOS, IFLAG 
       INTEGER HVCOD
       INTEGER KBUG

       REAL VISARR(128), FRMT, MXDF, PCTDIF 
       REAL IVBIAS(8), IVGAIN(8), IV2GAIN(8), IVALB 
       REAL SVBIAS(4), SVGAIN(4), SV2GAIN(4), SVALB 

       CHARACTER*16 PN

       COMMON/DBUG/KBUG
  
C ---  THE FOLLOWING DATA STATEMENTS ARE PREDETERMINED SCALING 
C ---  FACTORS USED TO UNSCALE THE SCALED RADIANCE SENT IN 
C ---  THE GVAR TRANSMISSION. 
  
       DATA IVBIAS/-0.154116E+02, -0.153044E+02, -0.153890E+02, 
     *             -0.152684E+02, -0.153111E+02, -0.152730E+02, 
     *             -0.153534E+02, -0.153300E+02/ 
       DATA IVGAIN/ 0.552808E+00,  0.550187E+00,  0.553975E+00, 
     *              0.550833E+00,  0.550946E+00,  0.552190E+00, 
     *              0.550459E+00,  0.550728E+00/ 
       DATA IV2GAIN/0.000000E+00,  0.000000E+00,  0.000000E+00, 
     *              0.000000E+00,  0.000000E+00,  0.000000E+00, 
     *              0.000000E+00,  0.000000E+00/ 
       DATA IVALB/  0.192979E-02/ 

       DATA SVBIAS/-0.603300E+02, -0.601600E+02, -0.617700E+02, 
     *             -0.615000E+02/ 
       DATA SVGAIN/ 0.648253E-01,  0.652221E-01,  0.656024E-01, 
     *              0.664202E-01/ 
       DATA SV2GAIN/0.000000E+00,  0.000000E+00,  0.000000E+00, 
     *              0.000000E+00/ 
       DATA SVALB/  0.220062E-02/ 

       DATA MXDF/   1.000000E-03/ 

       DATA PN/'(CHKVIS_IM.FOR)'/
  
       IFLAG = 0 
       NEWPOS = 1 
       CODPOS = 1 

       IF(MOD(ISAT,2) .EQ. 0) THEN 
C  
C---      EVEN-NUMBERED SSEC SATELLITE #: CHECK THE *IMAGER* VIS COEFFICIENTS 
C
C         CHECK IMAGER BIAS TERMS (1 PER DETECTOR) 
C
          DO 10 ITEMP=1,8 
C
C            -------------------------------------------------- 
C            GET THE PERCENT DIFFERENCE BETWEEN THE FACTORY 
C            VALUE AND THAT OF THE CODICIL VALUE.  IF IT IS 
C            GREATER THAN MXDF, THEN RETURN THE NEW COEFFICIENT 
C            AND SET THE WARNING MESSAGE FLAG TO 1 
C            -------------------------------------------------- 
C
             IF(PCTDIF(IVBIAS(ITEMP), FRMT(CODARR(CODPOS))) 
     *       .GT. MXDF .AND. HVCOD .EQ. 1) THEN 
                VISARR(NEWPOS) = FRMT(CODARR(CODPOS)) 
                IFLAG = 1 
             ELSE 
                VISARR(NEWPOS) = IVBIAS(ITEMP) 
             ENDIF 
             NEWPOS = NEWPOS + 1 
             CODPOS = CODPOS + 1 
10        CONTINUE 
C
C-----    CHECK IMAGER FIRST ORDER GAIN TERMS (1 PER DETECTOR) 
C
          DO 20 ITEMP=1,8 
             IF(PCTDIF(IVGAIN(ITEMP), FRMT(CODARR(CODPOS)))
     *       .GT. MXDF .AND. HVCOD .EQ. 1) THEN
                VISARR(NEWPOS) = FRMT(CODARR(CODPOS)) 
                IFLAG = 1 
             ELSE 
                VISARR(NEWPOS) = IVGAIN(ITEMP) 
             ENDIF 
             NEWPOS = NEWPOS + 1 
             CODPOS = CODPOS + 1 

C            CALL DMPARR(VISARR, 1, 25) 

20        CONTINUE 
C  
C-----    CHECK IMAGER SECOND ORDER GAIN TERMS (1 PER DETECTOR) 
C
          DO 30 ITEMP=1,8 
             IF(PCTDIF(IV2GAIN(ITEMP), FRMT(CODARR(CODPOS))) 
     *       .GT. MXDF .AND. HVCOD .EQ. 1) THEN 
                VISARR(NEWPOS) = FRMT(CODARR(CODPOS)) 
                IFLAG = 1 
             ELSE 
                VISARR(NEWPOS) = IV2GAIN(ITEMP) 
             ENDIF 
             NEWPOS = NEWPOS + 1 
             CODPOS = CODPOS + 1 
30        CONTINUE 
C
C-----    CHECK IMAGER ALBEDO FACTOR TERM (1 FOR ALL DETECTORS) 
C
          IF(PCTDIF(IVALB, FRMT(CODARR(CODPOS))) .GT. MXDF 
     *    .AND. HVCOD .EQ. 1) THEN 
             VISARR(NEWPOS) = FRMT(CODARR(CODPOS)) 
             IFLAG = 1 
          ELSE 
             VISARR(NEWPOS) = IVALB 
          ENDIF 

       ENDIF 
  
       IF(MOD(ISAT,2) .EQ. 1) THEN 
C  
C---      ODD-NUMBERED SSEC SATELLITE #: CHECK THE *SOUNDER* VIS COEFFICIENTS 
C
C---      CHECK SOUNDER BIAS TERMS (1 PER DETECTOR) 
C
          DO 40 ITEMP=1,4 
             IF(PCTDIF(SVBIAS(ITEMP), FRMT(CODARR(CODPOS))) 
     *       .GT. MXDF .AND. HVCOD .EQ. 1) THEN 
                VISARR(NEWPOS) = FRMT(CODARR(CODPOS)) 
                IFLAG = 1 
             ELSE 
                VISARR(NEWPOS) = SVBIAS(ITEMP) 
             ENDIF 
             NEWPOS = NEWPOS + 1 
             CODPOS = CODPOS + 1 
40        CONTINUE 
C  
C-----    CHECK SOUNDER FIRST ORDER GAIN TERMS (1 PER DETECTOR) 
C
          DO 50 ITEMP=1,4 
             IF(PCTDIF(SVGAIN(ITEMP), FRMT(CODARR(CODPOS))) 
     *       .GT. MXDF .AND. HVCOD .EQ. 1) THEN 
                VISARR(NEWPOS) = FRMT(CODARR(CODPOS)) 
                IFLAG = 1 
             ELSE 
                VISARR(NEWPOS) = SVGAIN(ITEMP) 
             ENDIF 
             NEWPOS = NEWPOS + 1 
             CODPOS = CODPOS + 1 
50        CONTINUE 
C  
C-----    CHECK SOUNDER SECOND ORDER GAIN TERMS (1 PER DETECTOR) 
C
          DO 60 ITEMP=1,4 
             IF(PCTDIF(SV2GAIN(ITEMP), FRMT(CODARR(CODPOS))) 
     *       .GT. MXDF .AND. HVCOD .EQ. 1) THEN 
                VISARR(NEWPOS) = FRMT(CODARR(CODPOS)) 
                IFLAG = 1 
             ELSE 
                VISARR(NEWPOS) = SV2GAIN(ITEMP) 
             ENDIF 
             NEWPOS = NEWPOS + 1 
             CODPOS = CODPOS + 1 
60        CONTINUE 
C  
C-----    CHECK SOUNDER ALBEDO TERM (1 FOR ALL DETECTORS) 
C
          IF(PCTDIF(SVALB, FRMT(CODARR(CODPOS))) .GT. MXDF
     *    .AND. HVCOD .EQ. 1) THEN 
             VISARR(NEWPOS) = FRMT(CODARR(CODPOS)) 
             IFLAG = IFLAG + 1 
          ELSE 
             VISARR(NEWPOS) = SVALB 
          ENDIF 

       ENDIF 
C  
C      CHECK IF FLAG HAS BEEN SET 
C
       IF(IFLAG .GT. 0 .AND. HVCOD .EQ. 1) THEN 
          IF(KBUG.GT.10) THEN
             CALL SDEST(PN//'VISIBLE CALIBRATION COEFFICIENTS '//
     *       'CHANGED: USING NEW...', 0) 
          ENDIF
          CALL DDEST('VISIBLE CALIBRATION COEF CHANGED: USING NEW', 0) 
       ENDIF 
       IF(HVCOD .EQ. 0) THEN
          IF(KBUG.GT.10) THEN
             CALL SDEST(PN//'NO CALIBRATION CODICIL: '//
     *       'USING DEFAULT...', 0)
          ENDIF
          CALL DDEST('NO CALIBRATION CODICIL: USING DEFAULT', 0)
       ENDIF

       RETURN 
       END 
