      INTEGER FUNCTION FINDOBMD(CIDN, num, MDNR, row)
C ***************************************************************
C  FINDOBMD.FOR		PROGRAMMED BY : Gerald Hartling 3/21/97
C     Searches the specified md file for a given station id.
C
C  INPUT:
C     CIDN		4-letter station id.
C     NUM               number of stations in the list.
C     MDNR 		MD file number to search.
C     ROW		Row in MD file to search.
C  OUTPUT:
C     If the station is found Returns the column that the station
C     is located in the md file, otherwise a -1 is returned.
C ***************************************************************
      include "imasos.h"
      character*4 cidn,cidnx,clit
      integer num, mdnr, row, low, high, mid, j
      integer irec(mkey)
    
      high = num
      low  = 1
      findobmd = -1

C ***************************************************************
C     Use a binary search to find the station.
C ***************************************************************
      do 20 while (low.le.high)
           do i=1,mkey
                irec(i) = 0
           enddo
           mid = (low+high)/2
           iok = mdget(mdnr, row, mid, irec)
           if (irec(5).eq.0) then
                high = mid - 1
                go to 20
           end if
           cidnx = clit(irec(5))
c          write(*, 100) cidn, mid, high, low, cidnx, row, mdnr
        do 10 j=1,4
           if ( cidn(j:j).eq.cidnx(j:j) ) then
                if ( j.eq.4 ) then
                     findobmd = mid
                     return
                endif
           else if ( cidn(j:j).lt.cidnx(j:j) ) then
                high = mid-1
                exit do 10 j=1 
           else if ( cidn(j:j).gt.cidnx(j:j) ) then
                low = mid+1
                exit do 10 j=1
           endif
  10    continue
  20  end do
 100  format (a4, 5x, i4, 5x, i4, 5x, i4, 5x, a4, 5x, i4, 5x, i4)

      RETURN
      END
