C *** McIDAS Revision History ***
C 1 GET_FILEPATH.FOR 15-Mar-01  JPN  initial version
C 2 GET_FILEPATH.FOR 30-May-01  JPN  -99 is now just a warning, KBUG 
C   to an integer
C *** McIDAS Revision History ***
C *$ Name:
C $      get_filepath - get the full pathname to the specified McIDAS-X file
C $
C $ Interface:
C $      integer function get_filepath(character*(*) file, character*(*) filepath)
C $
C $ Input:
C $      file           - name of McIDAS-X disk file
C $
C $ Input and Output:
C $      dbug           - integer debug flag
C $
C $ Output:
C $      filepath       - full pathname of the file, if found via either McIDAS-X
C $                       redirection or MCPATH
C $
C $      get_filepath   - function value
C $
C $              0      - success
C $            -99      - warning-- the LWFILE function cannot find the file via
C $                                 either redirection or MCPATH
C $           -199      - failure-- the LWFILE function successfully found the file,
C $                                 but the VOLNAM function cannot determine the fully-
C $                                 justified pathname to the file
C $
C $ Categories:
C $      UTILITY

      INTEGER FUNCTION GET_FILEPATH(FILENAME,FILEPATH)

      IMPLICIT NONE

      INTEGER          VOLNAM,LEN_TRIM,LWFILE     ! McIDAS-X functions

      INTEGER          RC,FILENAMELEN,PATHNAMELEN
      INTEGER          IFOUND

      CHARACTER*(*)    FILENAME,FILEPATH
      CHARACTER*1      BELL
      CHARACTER*19     PN

      LOGICAL          KBUG

      COMMON/DBUG/KBUG                            ! debugging common block

      DATA BELL/'*'/                            ! ASCII bell character = HEX 07
      DATA PN/'(GET_FILEPATH.FOR)'/
C
C     Initialize the output value of the function to 0, 
C     and initialize the path of the filename to blanks.
C
      GET_FILEPATH = 0
      FILEPATH = ' '

      FILENAMELEN = LEN_TRIM(FILENAME)
C
C     Check first to see if the file actually exists.
C
      IFOUND = LWFILE(FILENAME(1:FILENAMELEN))
      IF(IFOUND.EQ.0) THEN
C
C        The file does not exist anywhere within the current REDIRECT or MCPATH
C        configurations!
C
         GET_FILEPATH = -99
         CALL EDEST(PN//'WARNING: '//"'FILENAME(1:FILENAMELEN)'"//
     *   ' does not exist via either REDIRECT or MCPATH!',0)
         CALL SDEST(' ',0)
         RETURN
      ENDIF
C
C     The file DOES exist.  Note, however, that the file may have a zero
C     length, for whatever reason, which may yet cause problems!  In any
C     case, determine and return the full pathname to the file.
C
      RC = VOLNAM(FILENAME(1:FILENAMELEN),FILEPATH)
      IF(RC.LE.0) THEN
         GET_FILEPATH = -199
         CALL EDEST(BELL//PN//'ERROR: Cannot resolve path to '//
     *   "'FILENAME(1:FILENAMELEN)'",0)
         CALL SDEST(' ',0)
         RETURN
      ENDIF

      RETURN                                                   
      END                                                  
