	subroutine goespfco(ngoes,*)
c
c 04/10/2001 JPN  Read from goestbnd.dat is now being done via lwi.for;
c                 added "data" common block, for goespfco_write.for functionality
c
c * Input GOES/I-M Planck-function, band-cor'n & TSKIN coeff's
c        plus gammas, deltas, epsilons, and 'use' flags
c        NGOES = GOES satellite number, e.g. 8 (GOES/I)
c .... version of 22.03.01
c * updated to work with new 26-word FK1, FK2, etc. arrays read from goestbnd.dat 

c   This routine MUST be called before using GOESBRIT, GOESPLAN, GOESDBDT, or GOESSKIN.

	parameter (iuc=15,lenc=400,nk=26,nt=2,lenp=nk*(nt+3),lent=30)
	parameter (leng=nk*3,lenu=nk*nt,lenr=lenc*4)
	parameter (mbg=200,mbu=300)

        dimension icbuf(lenc)                 ! integer input array
        dimension cbuf(lenc)                  ! real input array

        character*12 cfi                      ! McIDAS-X function
	character*12 cfile                    ! file to read

        character*15 PN

c	common/gimgdx/gamma(nk),delta(nk),epsln(nk)
	common/gimgdx/gbuf(leng)

c	common/plncgx/cwn(nk),fk1(nk),fk2(nk),tc(nt,nk)
	common/plncgx/pbuf(lenp)
	common/tskcfx/tbuf(lent)

	common/use/ubuf(lenu)
        common/data/cbuf

        EQUIVALENCE (icbuf(1),cbuf(1))

        data PN/'(GOESPFCO.FOR)'/
	data cfile/'goestbnd.dat'/            ! file to read

C	irc=ngoes-7   ! Determine which record to read from goestbnd.dat.
	irc=(ngoes-(ngoes-1))   ! Determine which record to read from goestbnd.dat.
         
        istat = lwi(cfile,(irc-1)*lenc,lenc,icbuf)
  
        if(istat.ne.0) then
           call edest(PN//'ERROR reading LW record #'//
     *     cfi(irc)//' from '//cfile(1:len_trim(cfile))//
     *     '= '//cfi(istat),0)
           goto 100
        endif

CCC        open(iuc,file=cfile,recl=lenr,access='direct',status='old',
CCC     +		err=100)
CCC        read(iuc,rec=irc) cbuf
CCC        close(iuc)
c
c       Fill the "plncgx" common block (130 words, starting at word 1).
c
	do l=1,lenp
	   pbuf(l)=cbuf(l)
	enddo
c
c       Fill the "tskcgx" common block ( 30 words, starting at word 131).
c
	m=lenp
	do l=1,lent
	   m=m+1
	   tbuf(l)=cbuf(m)
	enddo
c
c       Fill the "gimgdx" common block ( 78 words, starting at word 201).
c
	m=mbg
	do l=1,leng
	   m=m+1
	   gbuf(l)=cbuf(m)
	enddo
c
c       Fill the "use" common block ( 52 words, starting at word 301).
c
	m=mbu
	do l=1,lenu
	   m=m+1
           ubuf(l)=cbuf(m)
	enddo

	return

100	return1
	end
