	function goesskin(tbb,ngoes,jtype)
c
c 4/10/2001 JPN  Added PN variable
c
c * Obtain Sfc-Skin-Temp from GOES/I-M TBB's
c .... version of 22.03.01
c
c    If retrieval cannot be made, e.g. because a channel is missing,
c     a value of MISSING (999999.) is returned.

c   Call GOESPFCO before using this or GOESBRIT or GOESDBDT or GOESPLAN

c * SOUNDER
c     jtype=0 for shortwave 'day' or 'night'
c             according to solar zenith angle
c     jtype=1 for shortwave 'day'         (17,18)
c     jtype=2 for shortwave 'night'       (16,17)
c     jtype=3 for l/w + s/w               (17,7,8)
c     jtype=4 for l/w 'split window - a'  (7,8)
c     jtype=5 for l/w 'split window - b'  (6,8)
c * IMAGER
c     jtype=10 for 'day' or 'night' according to solar zenith angle
c     jtype=11 for 'day'    (4,5/6)
c     jtype=12 for 'night'  (2,4,5/6)

	parameter (nbs=2,nps=3,ncs=4,nts=5)
	parameter (nbi=1,npi=4,nci=5,nti=2)

	common/tskcfx/coefs(ncs,nts),coefi(nci,nti)
	common/nav/glat,glon,gzen,szen,il,ie,iras,ipic,itime,jtime,jday

	dimension tbb(*),ics(nps,nbs),tps(nps)
	dimension ici(npi,nbi),tpi(npi)

        character*15 PN

	data (ics(i,1),i=1,nps)/16,17,18/
	data (ics(i,2),i=1,nps)/6,7,8/
	data (ici(i,1),i=1,npi)/22,23,24,25/
	data tmisg/999999./
        data PN/'(GOESSKIN.FOR)'/

	if(jtype.gt.9) go to 100

c * SOUNDER
	if(jtype.lt.3) then
	   k=1
	else
	   k=2
	endif
	do j=1,nps
	   i=ics(j,k)
	   if(jtype.eq.3.and.j.eq.1) i=17
	   tps(j)=tbb(i)
	enddo
	if(jtype.eq.0) then
	   if(szen.lt.90.) then
	      j=1
	   else
	      j=2
	   endif
	else
	   j=jtype
	endif
	tskin=coefs(ncs,j)
	do i=1,nps
	   c=coefs(i,j)
	   t=tps(i)
	   if(c.ne.0..and.t.eq.tmisg) go to 120
	   tskin=tskin+c*t
	enddo
	go to 110

c * IMAGER

100	k=1

	if(ngoes.eq.12) ici(npi,k)=26

	do j=1,npi
	   i=ici(j,k)
	   tpi(j)=tbb(i)
	enddo
	if(jtype.eq.10) then
	   if(szen.lt.90.) then
	      j=1
	   else
	      j=2
	   endif
	else
	   j=mod(jtype,10)
	endif
	tskin=coefi(nci,j)
	do i=1,npi
	   c=coefi(i,j)
	   t=tpi(i)
	   if(c.ne.0..and.t.eq.tmisg) go to 120
	   tskin=tskin+c*t
	enddo

110	goesskin=tskin
	return

120	goesskin=tmisg

	return
	end
