      SUBROUTINE OTOG2(XOB,YOB,NOB,NX,NY,QOB,AOB,QF,AF)                         
C $ SUBROUTINE OTOG2(XOB,YOB,NOB,NX,NY,QOB,AOB,QF,AF)          (CMH)            
C $ INTERPOLATE QOB AT OB POINTS TO QF AT GRID POINTS AND LIKEWISE AOB          
C $    AT OB POINTS TO AF AT GRID POINTS                                        
C $ XOB,YOB = (R) INPUT  LOCATIONS OF OBSERVATIONS                              
C $ NOB = (I) INPUT  NUMBER OF OBSERVATIONS                                     
C $ NX,NY = (I) INPUT  NO. OF GRIDPOINTS IN X AND Y DIRECTIONS                  
C $ QOB = (R) INPUT  OB QUALITY ARRAY WHICH IS INTERPOLATED INTO WEIGHT         
C $     FIELD                                                                   
C $ AOB = (R) INPUT  ANALYSIS VALUE AT THE OBSERVATION                          
C $ QF,AF = (R) INPUT/OUTPUT  ANALYSIS INCREMENT FIELDS                         
C $$ OTOG2 = VAS,COMPUTATION,GRID                                               
      DIMENSION XOB(1),YOB(1),QOB(1),QF(NX,NY),AOB(1),AF(NX,NY)                 
      DO 200 IOB=1,NOB                                                          
      IX=XOB(IOB)                                                               
      RX=XOB(IOB)-IX                                                            
      IX1=IX+1                                                                  
      IX2=IX+2                                                                  
      IF (IX2.GT.NX)IX2=NX                                                      
      IY=YOB(IOB)                                                               
      RY=YOB(IOB)-IY                                                            
      IY1=IY+1                                                                  
      IY2=IY+2                                                                  
      IF (IY2.GT.NY)IY2=NY                                                      
      RX1=1.-RX                                                                 
      RY1=1.-RY                                                                 
      RX1RY1=RX1*RY1                                                            
      RXRY1=RX*RY1                                                              
      RX1RY=RX1*RY                                                              
      RXRY=RX*RY                                                                
      A=AOB(IOB)                                                                
      Q=QOB(IOB)                                                                
      QF(IX1,IY1)=QF(IX1,IY1)+RX1RY1*Q                                          
      AF(IX1,IY1)=AF(IX1,IY1)+RX1RY1*A                                          
      QF(IX2,IY1)=QF(IX2,IY1)+RXRY1*Q                                           
      AF(IX2,IY1)=AF(IX2,IY1)+RXRY1*A                                           
      QF(IX1,IY2)=QF(IX1,IY2)+RX1RY*Q                                           
      AF(IX1,IY2)=AF(IX1,IY2)+RX1RY*A                                           
      QF(IX2,IY2)=QF(IX2,IY2)+RXRY*Q                                            
      AF(IX2,IY2)=AF(IX2,IY2)+RXRY*A                                            
  200 CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
