      SUBROUTINE RAOBIN(P,T,W,IOK)
C $ SUBROUTINE RAOBIN(P,T,W,IOK)                            (BTR)
C $ GETS RAOB DATA FROM MD FILE AND TRANSFORMS TO VAS COORDINATES
C $ P = (R) INPUT  PRESSURE
C $ T = (R) OUTPUT  TEMPERATURE
C $ W = (R) OUTPUT  MIXING RATIO
C $ IOK = (I) OUTPUT  FLAG        IF    =0 IS OK;
C $     =1 NO DATA; =2 NO REPORT; =3 REPORT HAS FEWER THAN 7 LEVELS;
C $     =4 SOUNDING DIDN'T REACH 100 MB; =5 SURFACE P, T OR W <0
C $$ RAOBIN = VAS,CONVERT,COMPUTATION
      CHARACTER*132 LBUF
      DIMENSION P(40),T(40),W(40),PR(100),TR(100),DR(100),WR(100),
     * D(100),S(100),Z(100),LEVS(100),ISTID(4),LR(15)
      COMMON/FLAFLO/FLAT,FLON
      COMMON/GUESS/TGES(15),DGES(6)
      COMMON/HISTOR/MD1,MD2
      COMMON/RAOB/MYDHH,NRAOB
      COMMON/SURF/IZ10,ITMP,IDEW,IPSTA,IEL,LSTA
      DATA LR/40,37,35,31,28,26,25,24,23,20,18,16,15,13,11/
      DATA T50/213./,WR/100*.001/,NML/40/,MCMSG/Z'80808080'/
      TS=.01*FLOAT(ITMP)
      PS=IPSTA
      IOK=1
C     CHECK TO SEE IF WE ARE USING OLD YYDDDHH FORM OR NEW YYDDDHHMM
      ICK=MYDHH/10000000
      ISC=1
      IF (ICK.GT.0)ISC=100
      MDA=MYDHH/(100*ISC)
      MHR=MOD(MYDHH,100*ISC)*10000/ISC
      ITYP=1
      IF(MD1.EQ.0) GO TO 10
      IF(MD2.EQ.0) ITYP=2
      GO TO 20
C     PICK UP CONTEMPORARY DATA
   10 LSD=MOD(MDA-1,10)+1
      MD1=LSD+10
      MD2=LSD+20
   20 IPRNT=0
      IF(NRAOB.LT.0) IPRNT=1
      NRAOB=IABS(NRAOB)
            CALL DDEST('TIME=',MHR)
            CALL DDEST('MD1=',MD1)
            CALL DDEST('MD2=',MD2)
            CALL DDEST('DAY=',MDA)
            CALL DDEST('IDN=',NRAOB)
      GO TO (30,40), ITYP
   30 CALL CSRAOB(7,MD1,MD2,MDA,MHR,NRAOB, NLEVS,ISTID,LEVS,
     * PR,TR,DR,D,S,Z,ISTAT)
      GO TO 50
   40 CALL UPRAOB(MD1,MDA,MHR,NRAOB, NLEVS,ISTID,LEVS,
     * PR,TR,DR,D,S,Z,ISTAT)
   50 IF(IPRNT.NE.0) CALL SDEST(' NO. OF RAOB LEVELS IS ',NLEVS)
      IF(ISTAT.EQ.-2) RETURN
      IOK=IOK+1
      IF(ISTAT.EQ.-1) RETURN
      IOK=IOK+1
      IF(NLEVS.LT.7) RETURN
      IOK=IOK+1
      IF(PR(NLEVS).GT.100.) RETURN
      L=0
      DO 120 I=1,NLEVS
      IF(PR(I).LT.1.) GO TO 120
      IF(TR(I).LT.150.) GO TO 120
      L=L+1
      PR(L)=PR(I)
      TR(L)=TR(I)
      DR(L)=DR(I)
      IF(DR(L).LT.150.) DR(L)=99.99
  120 CONTINUE
      NLEVS=L
      IF(IPRNT.EQ.0) GO TO 127
      CALL SDEST('ORIGINAL RAOB DATA',0)
      DO 123 I=1,NLEVS
      WRITE(LBUF,'(1X,F7.0,2F8.2)') PR(I),TR(I),DR(I)
      CALL LTQ(LBUF)
  123 CONTINUE
  127 CONTINUE
      IF(PR(NLEVS).LE.50.) GO TO 130
      NLEVS=NLEVS+1
      PR(NLEVS)=50.
      TR(NLEVS)=T50
      DR(NLEVS)=99.99
  130 DM=999.
      DO 140 I=1,NLEVS
      DP=ABS(PR(I)-100.)
      IF(DP.GT.DM) GO TO 140
      DM=DP
      ML=I
  140 CONTINUE
  150 IF(DR(ML).NE.99.99) GO TO 160
      ML=ML-1
      GO TO 150
  160 DO 170 I=1,ML
  170 DR(I)=TR(I)-DR(I)
      CALL WMIX(PR,TR,DR,WR,ML)
      IOK=IOK+1
      PS=PR(1)
      IF(PS.LE.0.) RETURN
      TS=TR(1)
      IF(TS.LE.0.) RETURN
      WS=WR(1)
      IF(WS.LE.0.) RETURN
      IF(IPSTA.EQ.0) IPSTA=PS
      IF(ITMP.EQ.0) ITMP=IROUND(TS*100.)
      DS=DEWPT(PS,TS,WS)
      IF(IDEW.EQ.0) IDEW=IROUND(DS*100.)
      IF(PS.GE.1000.) GO TO 190
      NLP1=NLEVS+1
      DO 180 I=1,NLEVS
      J=NLP1-I
      PR(J+1)=PR(J)
      TR(J+1)=TR(J)
  180 WR(J+1)=WR(J)
      PR(1)=1000.
      TR(1)=TR(2)
      WR(1)=.001
      IF(PR(2).GE.950.) WR(1)=WR(2)
      NLEVS=NLEVS+1
  190 DO 200 I=1,NML
      T(I)=-1.
      IT=I
      IF(P(I).GE.PR(NLEVS)) GO TO 210
  200 CONTINUE
  210 MML=NML-IT+1
      NLP1=NLEVS+1
      DO 220 I=1,NLEVS
      S(I)=PR(I)
      Z(I)=TR(I)
      D(I)=WR(I)
  220 CONTINUE
      DO 230 I=1,NLEVS
      J=NLP1-I
      PR(I)=S(J)
      TR(I)=Z(J)
      WR(I)=D(J)
  230 CONTINUE
      DO 240 I=1,NML
  240 W(I)=.001
      CALL INTPTW(PR,TR,WR,P(IT),T(IT),W(IT),NLEVS,MML)
  280 FLAT=FLOAT(ISTID(1))/10000.
      FLON=FLOAT(ISTID(2))/10000.
      LAT=IROUND(FLAT*100.)
      LON=IROUND(-FLON*100.)
      IEL=ISTID(3)
      IF(IEL.EQ.MCMSG) CALL VATOPO(LAT,LON,IEL,ICS)
      LSTA=LEVSFC(PS)
      CALL EXTEMP(T,FLAT)
      IOK=0
      DO 450 I=1,15
      L=LR(I)
  450 TGES(I)=T(L)
      DO 460 I=1,6
      L=LR(I)
      DGES(I)=DEWPT(P(L),T(L),W(L))
  460 CONTINUE
      IF(IPRNT.EQ.0) RETURN
      CALL SDEST('AFTER INTERPOLATION TO MODEL P-COORD',0)
      NL2=NML/2
      DO 470 I=1,NL2
      WRITE(LBUF,'(7X,F7.1,F7.2,F7.3,7X,F7.1,F7.2,F7.3)')
     * P(I),T(I),W(I),P(I+NL2),T(I+NL2),W(I+NL2)
  470 CONTINUE
      RETURN
      END
      SUBROUTINE RAOBAD(IOK)
C $ SUBROUTINE RAOBAD(IOK)                      (HMW)
C $ IOK = (I) INPUT  FLAG    IF     =0 OK
C $     =1 NO DATA; =2 NO REPORT; =3 REPORT HAS FEWER THAN 7 LEVELS;
C $     =4 SOUNDING DIDN'T REACH 100 MB; =5 SURFACE P, T OR W <0
C $$ RAOBAD = VAS
      COMMON/RAOB/MYDHH,NRAOB
      CALL SDEST(' *** UNABLE TO USE STATION ',NRAOB)
      GO TO (10,20,30,40,50), IOK
   10 CALL SDEST('      NO DATA FOR ',MYDHH)
      RETURN
   20 CALL SDEST('      NO REPORT',0)
      RETURN
   30 CALL SDEST('      REPORT HAS FEWER THAN 7 LEVELS',0)
      RETURN
   40 CALL SDEST('      SOUNDING DID NOT REACH 100 MB',0)
      RETURN
   50 CALL SDEST('      SURFACE P, T, OR W IS NEGATIVE',0)
      RETURN
      END
