      SUBROUTINE RFIL2(NX,NY,NSI,B1,B2,A,B)                                     
C $ SUBROUTINE RFIL2(NX,NY,NSI,B1,B2,A,B)                (CMH)                  
C $ RECURSIVE FILTER SUBROUTINE PACKAGE; APPLY RECURSIVE FILTERS IN X           
C $    AND Y ON BOUNDED DOMAIN TO TWO FIELDS AT A TIME                          
C $ NX,NY = (I) INPUT  NO. OF GRIDPOINTS IN X AND Y DIRECTIONS                  
C $ NSI = (I) INPUT  NUMBER OF SMOOTHING ITERATIONS EACH INCREMENT              
C $ B1,B2 = (R) INPUT  SMOOTHING PARAMETERS FOR X AND Y DIRECTIONS              
C $ A,B = (R) INPUT/OUTPUT  ANALYSIS INCREMENT FIELDS                           
C $$ RFIL2 = VAS,COMPUTATION                                                    
      DIMENSION A(NX,NY),B(NX,NY),B1(NX,NY),B2(NX,NY)                           
      NX1=NX-1                                                                  
      NY1=NY-1                                                                  
C  SMOOTH NSI TIMES USING PURSER'S PATENT 2ND-ORDER TRANSMISSIVE                
C  END CONDITIONS TO PROVIDE A PERFECT ANALYSIS EVERY TIME!                     
      DO 200 ISI=1,NSI                                                          
      DO 201 IY=1,NY                                                            
C  SCAN FORWARDS AND BACKWARDS WITH THE BASIC X-FILTER                          
      BE=B1(1,IY)                                                               
      AL=1.-BE                                                                  
      AL2=AL*AL                                                                 
      AL3=AL*AL2                                                                
      GA=1.-AL2                                                                 
      BEOGA=BE/GA                                                               
      BEOGAS=BEOGA/GA                                                           
      IF(ISI.EQ.1)THEN                                                          
      A(1,IY)=A(1,IY)*BE                                                        
      B(1,IY)=B(1,IY)*BE                                                        
      ELSEIF(ISI.EQ.2)THEN                                                      
      A(1,IY)=A(1,IY)*BEOGA                                                     
      B(1,IY)=B(1,IY)*BEOGA                                                     
      ELSEIF(ISI.GE.3)THEN                                                      
      A(1,IY)=(A(1,IY)-A(2,IY)*AL3)*BEOGAS                                      
      B(1,IY)=(B(1,IY)-B(2,IY)*AL3)*BEOGAS                                      
      ENDIF                                                                     
      DO 202 IX=2,NX                                                            
      A(IX,IY)=B1(IX,IY)*A(IX,IY)+(1.-B1(IX,IY))*A(IX-1,IY)                     
      B(IX,IY)=B1(IX,IY)*B(IX,IY)+(1.-B1(IX,IY))*B(IX-1,IY)                     
  202 CONTINUE                                                                  
      BE=B1(NX,IY)                                                              
      AL=1.-BE                                                                  
      AL2=AL*AL                                                                 
      AL3=AL*AL2                                                                
      GA=1.-AL2                                                                 
      BEOGA=BE/GA                                                               
      BEOGAS=BEOGA/GA                                                           
      IF(ISI.EQ.1)THEN                                                          
      A(NX,IY)=A(NX,IY)*BEOGA                                                   
      B(NX,IY)=B(NX,IY)*BEOGA                                                   
      ELSEIF(ISI.GE.2)THEN                                                      
      A(NX,IY)=(A(NX,IY)-A(NX1,IY)*AL3)*BEOGAS                                  
      B(NX,IY)=(B(NX,IY)-B(NX1,IY)*AL3)*BEOGAS                                  
      ENDIF                                                                     
      DO 203 IX=NX1,1,-1                                                        
      A(IX,IY)=B1(IX,IY)*A(IX,IY)+(1.-B1(IX,IY))*A(IX+1,IY)                     
      B(IX,IY)=B1(IX,IY)*B(IX,IY)+(1.-B1(IX,IY))*B(IX+1,IY)                     
  203 CONTINUE                                                                  
  201 CONTINUE                                                                  
C  SCAN FORWARDS AND BACKWARDS WITH THE BASIC Y-FILTER                          
      DO 204 IX=1,NX                                                            
      BE=B2(IX,1)                                                               
      AL=1.-BE                                                                  
      AL2=AL*AL                                                                 
      AL3=AL*AL2                                                                
      GA=1.-AL2                                                                 
      BEOGA=BE/GA                                                               
      BEOGAS=BEOGA/GA                                                           
      IF(ISI.EQ.1)THEN                                                          
      A(IX,1)=A(IX,1)*BE                                                        
      B(IX,1)=B(IX,1)*BE                                                        
      ELSEIF(ISI.EQ.2)THEN                                                      
      A(IX,1)=A(IX,1)*BEOGA                                                     
      B(IX,1)=B(IX,1)*BEOGA                                                     
      ELSEIF(ISI.GE.3)THEN                                                      
      A(IX,1)=(A(IX,1)-A(IX,2)*AL3)*BEOGAS                                      
      B(IX,1)=(B(IX,1)-B(IX,2)*AL3)*BEOGAS                                      
      ENDIF                                                                     
      DO 205 IY=2,NY                                                            
      A(IX,IY)=B2(IX,IY)*A(IX,IY)+(1.-B2(IX,IY))*A(IX,IY-1)                     
      B(IX,IY)=B2(IX,IY)*B(IX,IY)+(1.-B2(IX,IY))*B(IX,IY-1)                     
  205 CONTINUE                                                                  
      BE=B2(IX,NY)                                                              
      AL=1.-BE                                                                  
      AL2=AL*AL                                                                 
      AL3=AL*AL2                                                                
      GA=1.-AL2                                                                 
      BEOGA=BE/GA                                                               
      BEOGAS=BEOGA/GA                                                           
      IF(ISI.EQ.1)THEN                                                          
      A(IX,NY)=A(IX,NY)*BEOGA                                                   
      B(IX,NY)=B(IX,NY)*BEOGA                                                   
      ELSEIF(ISI.GE.2)THEN                                                      
      A(IX,NY)=(A(IX,NY)-A(IX,NY1)*AL3)*BEOGAS                                  
      B(IX,NY)=(B(IX,NY)-B(IX,NY1)*AL3)*BEOGAS                                  
      ENDIF                                                                     
      DO 207 IY=NY1,1,-1                                                        
      A(IX,IY)=B2(IX,IY)*A(IX,IY)+(1.-B2(IX,IY))*A(IX,IY+1)                     
      B(IX,IY)=B2(IX,IY)*B(IX,IY)+(1.-B2(IX,IY))*B(IX,IY+1)                     
  207 CONTINUE                                                                  
  204 CONTINUE                                                                  
  200 CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
