      SUBROUTINE RORDER(B,A,NI,M,IDIR)
C $ SUBROUTINE RORDER(B,A,NI,M,IDIR)
C $ RORDER - Sort array in ascending or descending order
C $ Input:
C $     B = (R) array of numbers to be sorted
C $     M = (I) number of values to be sorted
C $     IDIR = (I) indicates if ascending (=1) or descending (=2) sort
C $ Output:
C $     A = (R)  array of numbers in sorted order
C $     NI = (I) array of positions of B values in A array
C $$ RORDER = COMPUTAT, SOUNDER, TOVS
      DIMENSION A(*),B(*),NI(*)
C
C        'B' = BEFORE
C        'A' = AFTER
C
C *** THIS ROUTINE ORDERS THE DATA IN THE ARRAY 'B' FROM SMALLEST TO
C        LARGEST (IDIR=1), OR LARGEST TO SMALLEST (IDIR=2).  THE RE-
C        ORDERED DATA IS RETURNED IN THE ARRAY 'A'.
C        UPON COMPLETION OF THE ORDERING, THE ARRAY 'NI' CONTAINS THE
C        ORIGINAL POSITIONAL SUBSCRIPTS OF 'B' IN THE NEW ORDER.  THIS
C        INDEX ARRAY CAN THEN BE USED TO ORDER OTHER DATA ASSOCIATED
C        WITH THE DATA IN 'B'.
C
C        'M' IS THE NUMBER OF ELEMENTS TO BE ORDERED.
C
C *** INITIALIZE 'A' AND 'NI'
      DO 100 I=1,M
      NI(I)=I
  100 A(I)=B(I)
      IF (M .EQ. 1) RETURN
C *** ORDER A(1) AND A(2) *****
      GO TO (110,120), IDIR
  110 IF(A(2).GT.A(1)) GO TO 140
      GO TO 130
  120 IF(A(1).GT.A(2)) GO TO 140
  130 NS=NI(1)
      NI(1)=NI(2)
      NI(2)=NS
      S=A(1)
      A(1)=A(2)
      A(2)=S
  140 IF(M.EQ.2) RETURN
      MM=M-1
C *** BISECT A(1)---A(N) REPEATEDLY *****
      L=0
      N1=1
  150 L=L+1
      N1=N1*2
      N2=N1*2-1
      IF(N2.GT.MM) N2=MM
      DO 260 N=N1,N2
      NS=NI(N+1)
      S=A(N+1)
      FN=N
      F=1.+FN/2.
      K=F
      D=2.
      DO 210 I=1,L
      D=D*2.
      GO TO (160,170), IDIR
  160 IF(S-A(K)) 190,240,180
  170 IF(A(K)-S) 190,240,180
  180 F=F+FN/D
      GO TO 200
  190 F=F-FN/D
  200 K=F
  210 CONTINUE
C *** INSERT A(N+1) *****
      GO TO (220,230), IDIR
  220 IF(S.GT.A(K)) K=K+1
      GO TO 240
  230 IF(A(K).GT.S) K=K+1
  240 DO 250 I=K,N
      J=N+K-I
      NI(J+1)=NI(J)
      A(J+1)=A(J)
  250 CONTINUE
      NI(K)=NS
      A(K)=S
  260 CONTINUE
      IF(N2.LT.MM) GO TO 150
      RETURN
      END
