      SUBROUTINE VATOPO (MLAT,MLON,IELEV,ICHAR)
C ?   MLAT (INPUT) LATITUTE *100
C ?   MLON (INPUT) LONGITUDE*100 (+ 0-180 EAST; 0- -180 WEST)
C ?   IELEV (OUTPUT) ELEVATION (METERS)
C ?   ICHAR (OUTPUT) PRIMARY CHARACTERISTIC)
C
      PARAMETER (NBOX = 4)
      REAL*8 DLAT, DLON, DLAX
      REAL   SIXTH, ELEMOD, ELEMAX, ELEMIN
C IBUF dimensioned for a 5 deg X 5 deg box spaced at 10 minutes, giving
C 6 points per linear degree. Therefore 30 points per row/column.
C Each point uses 2 words.  Therefore there are  30 x 30 = 900 points.
      INTEGER IBUF(900,2,NBOX), IWORD, IWORD1, IWORD2
      INTEGER JBUF(1800,NBOX)
      EQUIVALENCE (IBUF,JBUF)
      INTEGER INDEXA(NBOX), IXROW(NBOX), IXCOL(NBOX)
      INTEGER NRIDGE,DRIDGE,MODELE,MAXELE,MINELE,PRIMCH,SECNCH,
     1        PCWATR,PCURBN
      COMMON /CMTOPO/ NRIDGE,DRIDGE,MODELE,MAXELE,MINELE,PRIMCH,SECNCH,
     1         PCWATR,PCURBN, ELEMOD,ELEMAX,ELEMIN
c Significant Ridges -
c         Subjective estimate of number of ridges and their
c          orientation in tens of degrees (00-18).

c Terrain Elevation -

c         Elevation in feet = (packed value - 100)*100.

c         Note that zero values do not necessarily indicate
c          ocean surface.  Use primary terrain characteristic
c          to identify ocean.
c         Inland water bodies are coded with the elevation of
c          the water surface (except in minimum field where it
c          is always zero).

c Characteristics of the Terrain -
c         0-      salt or lake bed.
c         1-      flat or relatively flat.
c         2-      desert (or, for high latitudes, glaciers
c                   or permanent ice).
c         3-      marsh.
c         4-      lake country or atoll.
c         5-      major valleys or river beds.
c         6-      isolated mountains, ridge or peak.
c         7-      low mountains or hills.
c         8-      average mountains.
c         9-      extremely rugged mountains.

c        62-      ocean (identified in primary only).

c Percentage of water -
c         For ocean areas at sea level the value is 100, for all
c          other areas the range is 00 to 99 (large lakes or
c          inland seas will not be coded as 100).

c Percentage of Urban Development -
c         Not updated (reflects highly subjective judgements from
c          the maps used).

C      INTEGER MASK1 /Z0000003F/, MASK2 /Z000001FF/, MASK3 /Z00000003/,
C     1        MASK4 /Z0000007F/, MASK5 /Z0000001F/
C      INTEGER IREC /-1/
      INTEGER MASK1, MASK2, MASK3, MASK4, MASK5
      INTEGER IREC
      LOGICAL LINIT
      CHARACTER*7 FILEIN
C      LOGICAL LINIT /.TRUE./
C      CHARACTER FILEIN*7 /'TOPOGMC'/
      character cfl*132
      DATA MASK1/Z'0000003F'/, MASK2/Z'000001FF'/, MASK3/Z'00000003'/,
     1        MASK4/Z'0000007F'/, MASK5/Z'0000001F'/
      DATA IREC/-1/ 
      DATA LINIT/.TRUE./
      DATA FILEIN/'TOPOGMC'/
C
      IF (LINIT) THEN
       OPEN (UNIT=1,IOSTAT=IOSTAT,ERR=92,FILE=FILEIN,STATUS='OLD',
     1     ACCESS='DIRECT',FORM='UNFORMATTED',RECL=28800)
C     1     ACCESS='DIRECT',FORM='UNFORMATTED',RECL=7200)
       SIXTH = 100. / 6.
       DO I=1,NBOX
        INDEXA(I) = -1
       ENDDO
       LINIT = .FALSE.
      ENDIF
      MLAX = MLAT + 9000
      MLOX = MLON
      IF (MLON .LT. 0) MLOX = 36000 + MLON
      IROW = MLAX / 500
      ICOL =  MLOX / 500 + 1
      NREC = (IROW*72) + ICOL
      IF (NREC .GT. 2592) NREC = 2592
 6000 format (i5,i3,i4,1x,4(i5,i3,i4))
      DO 1 I=1,NBOX
       IF (NREC .EQ. INDEXA(I)) THEN
        IX = I
        GOTO 8
       ENDIF
 1    CONTINUE
C Box not present, use unfilled box (indexa = -1) or western most box.
      DO 2 I=1,NBOX
       IF (INDEXA(I) .EQ. -1) THEN
        IX = I
        GOTO 6
       ENDIF
 2    CONTINUE
C Determine Western most box.
C The row and column for each of the boxes have been saved in IXROW &
C IXCOL.  IROW & ICOL are current desired row & column.  Get the minimum
C column for IROW and the minimum column for all (also the maximums for
C the cross the date line case).
      IRMIN =  99999
      IXMIN =  99999
      IRMAX = -99999
      IXMAX = -99999
      IDMAX = -9999
      DO 3 i=1,NBOX
      IF (IXROW(I).EQ.IROW .AND. IXCOL(I).LT.IRMIN) THEN
       IRMIN = IXCOL(I)
       KRMIN = I
      ENDIF
      IF (IXROW(I).EQ.IROW .AND. IXCOL(I).GT.IRMAX) THEN
       IRMAX = IXCOL(I)
       KRMAX = I
      ENDIF
      IF (IXCOL(I).LT.IXMIN) THEN
       IXMIN = IXCOL(I)
       KXMIN = I
      ENDIF
      IF (IXCOL(I).GT.IXMAX) THEN
       IXMAX = IXCOL(I)
       KXMAX = I
      ENDIF
      IDC = IABS(IXCOL(I)-ICOL)
      IF (IDC .GT. 36) IDC = 72 - IDC
      IDR = IXROW(I) - IROW
      IDS = IDR*IDR + IDC*IDC
      IF (IDS .GT. IDMAX)THEN
       IDMAX = IDS
       IDX = I
      ENDIF
 3    CONTINUE
      IX = IDX
 6    CONTINUE
      READ (1,REC=NREC,IOSTAT=IOSTAT,ERR=93) (JBUF(I,IX),I=1,1800)
      INDEXA(IX) = NREC
      IXROW(IX) = IROW
      IXCOL(IX) = ICOL
 8    CONTINUE
      FILAT = MOD(MLAX,500)
      FILON = MOD(MLOX,500)
      ILAT = FILAT / SIXTH
      ILON = FILON / SIXTH + 1.0
      LOC = (ILAT * 30) + ILON
      IWORD1 = IBUF(LOC,1,IX)
      IWORD2 = IBUF(LOC,2,IX)
      NRIDGE = IAND(ISHFT(IWORD1,-26),MASK1)
      DRIDGE = IAND(ISHFT(IWORD1,-20),MASK1)
      MODELE = IAND(ISHFT(IWORD1,-11),MASK2)
      MAXELE = IAND(ISHFT(IWORD1,- 2),MASK2)
      MINELE = ISHFT(IAND(IWORD1,MASK3),7)
      IWORD  = IAND(ISHFT(IWORD2,-25),MASK4)
      MINELE = IOR(MINELE,IWORD)
      PRIMCH = IAND(ISHFT(IWORD2,-19),MASK1)
      SECNCH = IAND(ISHFT(IWORD2,-14),MASK5)
      PCWATR = IAND(ISHFT(IWORD2,- 7),MASK4)
      PCURBN = IAND(IWORD2,MASK4)
      ELEMOD = (MODELE * 100) * 0.3048
      ELEMAX = (MAXELE * 100) * 0.3048
      ELEMIN = (MINELE * 100) * 0.3048
      IELEV = ELEMOD
      ICHAR = PRIMCH
      IF (PRIMCH .EQ. 62) ICHAR = 0
      IF (PRIMCH .EQ. 0 .AND. PCWATR.LT.100) ICHAR = SECNCH
      RETURN
 92   WRITE (6,692) IOSTAT,FILEOU
 692  FORMAT ('output OPEN error IOSTAT=',i8,' file: ',A24)
      STOP
 93   WRITE (6,693) IOSTAT,NREC
 693  FORMAT ('input READ error IOSTAT=',i8,' nrec= ',I6)
      STOP
      END
