      SUBROUTINE WINCOR (FI,FJ,ITAB,U,V,SPEED,DIR,ULL,VLL)
      INTEGER ITAB(64)
      PARAMETER (PI = 3.1415926 , RAD = PI / 180. )
      PARAMETER (PI2 = PI*2. , RADDEG = 180. / PI )
      GNC(AV,BD)=-AV*COS(BD)
      GMC(AV,BD)=-AV*SIN(BD)
      IF (ITAB(34) .EQ. 1) GO TO 100
      IF (ITAB(34) .GT. 4) GO TO 200
      RNP = ITAB(35) * 0.0001
      CNP = ITAB(36) * 0.0001
CCC   NR = ITAB(2)
CCC   NC = ITAB(3)
C        FLIP THE ROW INDEX BUT NOT THE COLUMN. (1,1) IS AT UL FROM LLIJ
      XI = FI - CNP
      XJ = FJ - RNP
      XI = -XI
      CALL W3FC02 (XI,XJ,U,V,DIR,SPEED)
      DIR = AMOD(DIR,360.)
        IF ((U.EQ.0.0) .AND. (V.EQ.0.0)) THEN
        UFIELD = 0.0
        VFIELD = 0.0
        END IF
      DIRR = DIR * RAD
      ULL =  GMC(SPEED,DIRR)
      VLL =  GNC(SPEED,DIRR)
      RETURN
 100  CONTINUE
      IF ((U.NE.0.0) .OR. (V.NE.0.0)) DIR = ATAN2(U,V)
      DIR = DIR + PI
      DIR = AMOD(DIR,PI2) * RADDEG
      SPEED = V*V + U*U
      SPEED = SQRT(SPEED)
      ULL = U
      VLL = V
      RETURN
 200  CONTINUE
      CALL EDEST ('GRID TYPE NOT RECOGNIZED, TYPE=',ITAB(34))
      RETURN
      END
      SUBROUTINE W3FC02 (FFID,FFJD,FGU,FGV,DIR,SPD)
C $ GEARY CALLAN NOAA/NESDIS NMC ROUTINE        (GMC)
C GIVEN THE GRID-ORIENTED WIND COMPONENTS ON A NORTHERN HEMISPHERE POLAR
C STEREOGRAPHIC GRID POINT, COMPUTE THE DIRECTION AND SPEED OF THE WIND
C AT THAT POINT. INPUT WINDS AT THE NORTH POLE POINT ARE ASSUMED TO HAVE
C THIER COMPONENTS FOLLOW THE WMO STANDARDS FOR REPORTING WINDS AT THE
C NORTH POLE. (SEE OFFICE NOTE 241 FOR WMO DEFINITION).
C INPUT ARGUEMENTS:
C   FFID - REAL*4 = I(NORTH POLE) - I(POINT)
C   FFJD - REAL*4 = J(NORTH POLE) - J(POINT)
C   FGU  - REAL84 = GRID-ORIENTED U-COMPONENT
C   FGV  - READ*4 = GRID-ORIENTED V-COMPONENT
C OUTPUT ARGUEMENTS:
C   DIR - REAL*4 = WIND DIRECTION, DEGREES
C   SPD - REAL*4 = WIND SPEED
C
      SPD = SQRT(FGU*FGU + FGV*FGV)
      IF (SPD .NE. 0.0) GO TO 1000
      FGU = 0.
      FGV = 0.
      GO TO 3000
 1000 CONTINUE
      DFP = SQRT(FFID*FFID + FFJD*FFJD)
      IF (DFP .NE. 0.0) GO TO 2000
      XLAM = ACOS(FGU / SPD)
      XLAM = XLAM * 57.29578
      IF (FGV .LT. 0.0) DIR = 170. + XLAM
      IF ((FGV.GT.0.) .AND. (XLAM.LT.170.)) DIR = 170. - XLAM
      IF ((FGV.GT.0.) .AND. (XLAM.GE.170.)) DIR = 530. - XLAM
      IF ((ABS(FGV).LE.0.001) .AND. (FGU.GT.0.)) DIR = 170.
      IF ((ABS(FGV).LE.0.001) .AND. (FGU.LT.0.)) DIR = 350
      GO TO 3000
 2000 CONTINUE
      CAL = FFJD / DFP
      SAL = FFID / DFP
      U = FGU * CAL - FGV * SAL
      V = FGU * SAL + FGV * CAL
      DIR = 57.29578 * ATAN2(U,V) + 180.
 3000 CONTINUE
      RETURN
      END
