/* This routine combines individual lines into one, the guts of gimiglue */
#include <stdio.h>
#include "gimfiles.h"
#include "gimparm.h"
#include "gcmcidas.h"
#include "direct.h"
#include "bandparams.h"
extern Direct_ptr dirp[6];      /* uses direct.h */
#define PFXLEN 120
/*#define LINLEN 4000		defined in gimparm.h */
/*#define OUTLEN 12500		defined in gimparm.h */
int  redarax (int fd, int line, int elem, int nele, int  *buf);
extern bug;

int gcombine (void)
{
 static int i, j;			/* loop index */
 static int ln, el, fl;	/* line, element, file indices */
 static int i_line;		/* line of area0 in image coordinates */
 static int a_line;		/* line of areai in area coordinates */
 static int i_elem;		/* element of area0 in image coordinates */
 static int a_elem;		/* element of areai in area coordinates */
 static int s_p;		/* prefix length in short units */
 static int band_av[MAXCMDOPT];	/* band availability for a particular line */
 static int status;		/* function status return */
 static int  prefix[PFXLEN*(MAXCMDOPT)];	/* storage for prefix */
 static int no_bands;		/* number of bands for a line */
 static int map_band[MAXBANDS];	/* list of bands present for a line. */
 static int map_file[MAXBANDS];	/* The file for each band in map_band. */
 static int map_off[MAXBANDS];	/* offset of band in pixel for map_file. */
 static int  outbuf[OUTLEN];
 static int  lines[LINLEN*MAXBANDS];	/* input line data */
 static short pixele;		/* pixel element to hold one band of data */
 static int offset;		/* band offset in pixel */
 static int channel;
 static int len_writ_out;	/* length of outbuf to write in words */
 static int pfx_len;		/* output prefix length */
 
 printf("in gcombine\n");
 #ifdef JUNK
 len_writ_out = dirp[0]->line_pref +
                (dirp[0]->nele * dirp[0]->nbands * dirp[0]->data_bytes)/4;
 if (len_writ_out > OUTLEN)
  {printf("output buffer not large enough need %d words\n", len_writ_out);
   return -1;}
 #endif

 for (ln=0; ln<dirp[0]->nlin; ln++)
  {
   /*if (ln > 4) break;*/	/* DEBUG */
   i_line = dirp[0]->lcor + (ln*dirp[0]->lres);	/* image line number area0 */
   /* Loop through input files */
   for (fl=1; fl<=num_in_files; fl++)
    {
     a_line = (i_line - dirp[fl]->lcor) / dirp[fl]->lres;
     if ((a_line < 0) || (a_line > dirp[fl]->nlin))
      {band_av[fl] = 0; continue;}
      else
      {band_av[fl] = 1;}
     status = redpfx (gf[fl].fileno, a_line, &prefix[fl*PFXLEN]);
     if (status != 0)
      {printf("redpfx failed %1d %4d\n", fl,a_line);
       band_av[fl] = 0; continue;}
     if (bug > 0) printf("prefix area %1d line %4d", fl, a_line); /* DEBUG */
     #ifdef JUNK
     if ( !gp.lev_flag[fl] ) /* Do this if there is a level section */
      {for (i=0; i<MAXBANDS; i++)
        {if (*(char *)(prefix+(fl*PFXLEN*4+gp.lev_loc[fl]+i)) >0)
         if (bug > 0)		/* DEBUG */
           printf(" %1d",(char *)(prefix+(fl*PFXLEN*4+gp.lev_loc[fl]+i)) );/*DEBUG*/
        }
        /* Get offset for this band put in gp.lev_off[0-4] */
      }
     #endif
     if (bug > 0) printf("\n"); /* DEBUG */
     status = redarax (gf[fl].fileno, a_line, 0, dirp[fl]->nele,
       &lines[LINLEN*(fl-1)]);
     if (status != 0) {printf("redara failed %1d %4d\n", fl,a_line);}
     if (bug > 0)		/* DEBUG */
     printf("%1d %08x %08x %08x %08x %08x %08x %08x\n",
       fl, lines[LINLEN*(fl-1)],
       lines[LINLEN*(fl-1)+1], lines[LINLEN*(fl-1)+2],
       lines[LINLEN*(fl-1)+3], lines[LINLEN*(fl-1)+4],
       lines[LINLEN*(fl-1)+5], lines[LINLEN*(fl-1)+6]); /* DEBUG */
    }		/* end of file loop on fl */

   /* Copy a line prefix to the output buffer.  Prefer area1 but will take the
      first available. */
   for (i=0; i<len_writ_out; i++) {outbuf[i] = 0;}
   for (fl=1; fl<=num_in_files; fl++)
    {
     if (band_av[fl] == 0) continue;
     /* Do not copy level section */
     /* Assume that all prefix length are the same but if they are not then
        try to wriggle out with some spurious assumptions. */
     pfx_len = dirp[fl]->len_doc+dirp[fl]->len_cal;
     if (pfx_len > dirp[0]->len_doc+dirp[0]->len_cal)
      {pfx_len = dirp[0]->len_doc+dirp[0]->len_cal;}
     for (i=0; i<(dirp[fl]->len_doc+dirp[fl]->len_cal)/4; i++)
      {outbuf[i] = prefix[fl*PFXLEN+i];}
     break;
    }

   no_bands = 0;
   for (i=0; i<MAXBANDS; i++)
    {
     fl = gp.chan_loc[i];
     map_band[i] = 0;	/* no band */
     if ( !gp.chan_loc[i] ) continue; /* This band not available. */
     map_band[no_bands] = i + 1;	/* one based band number */
     map_file[no_bands] = gp.chan_loc[i];
     map_off[no_bands] = gp.lev_off[i];
     if ( !gp.lev_flag[fl] ) /* Do this if there is a level section */
      {
       if (bug > 0)
        {printf("prefix area offset band %1d",i); /* DEBUG */
         printf(" %2d %2d %2d", gp.lev_off[i], fl, gp.lev_loc[fl]); /* DEBUG */
         printf(" %08x %08x", prefix[fl*PFXLEN+19], prefix[fl*PFXLEN+20]);} /* DEBUG */
       for (j=0; j<MAXBANDS; j++)
        {
         if (bug > 0)
         printf(" %1d",*(((char *)prefix)+(fl*PFXLEN*4+gp.lev_loc[fl]+j)) );/*DEBUG*/
         channel = *(((char *)prefix)+(fl*PFXLEN*4+gp.lev_loc[fl]+j));
         if (bug > 0) printf(" chan %1d", channel); /* DEBUG */
         if (*(((char *)prefix)+(fl*PFXLEN*4+gp.lev_loc[fl]+j)) == i+1)
          {offset = j;  map_off[no_bands] = j; break;}
         /*
         if (*(((char *)prefix)+(fl*PFXLEN*4+gp.lev_loc[fl]+j)) == 0) break;
         */
        }
        /* Get offset for this band put in gp.lev_off[0-4] */
       if (bug > 0) printf("\n"); /* DEBUG */
      }
     no_bands++;
    }
   if (bug > 0)
    {printf("no bands %d\n", no_bands);
     printf("map band %2d %2d %2d %2d %2d\n",
      map_band[0],map_band[1],map_band[2],map_band[3],map_band[4]);
     printf("map file %2d %2d %2d %2d %2d\n",
      map_file[0],map_file[1],map_file[2],map_file[3],map_file[4]);
     printf("map off  %2d %2d %2d %2d %2d\n",
      map_off[0],map_off[1],map_off[2],map_off[3],map_off[4]);}

   j = gp.lev_loc[0];	/* start of level section (bytes) for area0 */
   for (i=0; i<MAXBANDS; i++) { *(((char *)outbuf)+j+i) = (char)map_band[i]; }
   if (bug > 0)
    {printf("level %08x %08x %d\n", outbuf[j/4], outbuf[j/4+1], j);} /* DEBUG */

   s_p = dirp[0]->line_pref / 2;
   if (bug > 0) {printf("s_p %d nb %d\n", s_p, dirp[0]->nbands);}   /* DEBUG */
   /* This loop probably takes up the most time */
   /* This loop is for 2 byte data. */
   for (el=0; el<dirp[0]->nele; el++)
    {
     i_elem = dirp[0]->ecor + (el*dirp[0]->eres);
     for (i=0; i<dirp[0]->nbands; i++)
      {
       if (map_band[i] < 1) break;
       j = map_file[i] - 1;	/* indices for lines is 0 - 4 */
       /*a_elem = (i_elem - dirp[j+1]->ecor) / dirp[j+1]->eres;*/
       a_elem = ((i_elem - dirp[j+1]->ecor) / dirp[j+1]->eres) *
                 dirp[j+1]->nbands + map_off[i];
       if (a_elem < 0) continue;
       pixele = *(((short *)&(lines[LINLEN*j]))+a_elem);
       *(((short *)outbuf) + s_p + el*dirp[0]->nbands + i) = pixele;
      }
     /*if ((a_elem < 0) || (a_elem > dirp[fl]->nele))*/
    }
   if (bug > 0)
    {printf("%08x %08x %08x %08x %08x %08x %08x %08x %08x\n",
     outbuf[19], outbuf[20], outbuf[21], outbuf[22], outbuf[23], outbuf[24],
     outbuf[25], outbuf[26], outbuf[27]);
    }

   status = wrtara(gf[0].fileno, ln, outbuf);

  }	/* end of line loop on ln */

 return 0;
}
