#include <stdio.h>
#include "gimparm.h"
#include "gimfiles.h"
#include "direct.h"
#include "bandparams.h"
extern Direct_ptr dirp[MAXCMDOPT];

int gg_check (void)
{
 int i;		/* loop index */
 int  parm;	/* holds what is being checked */

 /* At this point num_in_files is > 1.  Must be combining 2 or more files */
 parm = dirp[1]->yyddd;
 for (i=2; i<num_in_files; i++)
  {
   if (parm != dirp[i]->yyddd)
    {printf("date mismatch file %d date %d should be %d\n",
     i, parm, dirp[i]->yyddd);}
  }

 parm = dirp[1]->time;
 for (i=2; i<num_in_files; i++)
  {
   if (parm != dirp[i]->time)
    {printf("time mismatch file %d date %d should be %d\n",
     i, parm, dirp[i]->time);}
  }

 parm = dirp[1]->data_bytes;
 for (i=2; i<num_in_files; i++)
  {
   if (parm != dirp[i]->data_bytes)
    {printf("bytes per data element mismatch file %d num %d should be %d\n",
     i, parm, dirp[i]->data_bytes);}
  }

 parm = dirp[1]->source_type;
 for (i=2; i<num_in_files; i++)
  {
   if (parm != dirp[i]->source_type)
    {printf("source type mismatch file %.4s type %.4s should be %d\n",
     i, &parm, &dirp[i]->source_type);
     return -1;}	/* serious, end run */
  }

 parm = dirp[1]->calib_type;
 for (i=2; i<num_in_files; i++)
  {
   if (parm != dirp[i]->calib_type)
    {printf("calibration type mismatch file %.4s cal %.4s should be %d\n",
     i, &parm, &dirp[i]->calib_type);}
  }

 parm = dirp[1]->len_doc;
 for (i=2; i<num_in_files; i++)
  {
   if (parm != dirp[i]->len_doc)
    {printf("prefix documentation length mismatch file %d length %d should be %d\n",
     i, parm, dirp[i]->len_doc);}
  }

 parm = (dirp[0]->line_pref +
         dirp[0]->nele * dirp[0]->nbands * dirp[0]->data_bytes)/4;
 if (parm > OUTLEN)
  {printf("output buffer not large enough need %d words\n", parm);
   printf ("set OUTLEN to %d in gimparm.h\n", parm);
   return -1;}

 /* Check input line lengths.  Must be less than LINLEN. */
 for (i=1; i<num_in_files; i++)
  {
   parm = (dirp[i]->nele * dirp[i]->nbands * dirp[i]->data_bytes)/4;
   if (parm > LINLEN)
    {printf("output buffer not large enough need %d words\n", parm);
     printf ("set LINLEN to %d in gimparm.h\n", parm);
     return -1;}
  }

 return 0;
}
