#include <stdio.h>
#include <errno.h>
#include <unistd.h>	/* read, write, lseek, close */
#include "aracom.h"
#include "direct.h"

extern char **varg;

/*  STATUS = REDARA (area,line,elem,nele,band,iarray)
    REDARA - Read line from area returning specified subset of line
    Input:
      AREA = (I) area number
      LINE = (I) line to read
      ELEM = (I) starting element desired. 0 returns first byte of data
      NELE = (I) number of elements. Will not return any past line end
    OUTPUT:
      IARRAY = (I) array to hold returned data */

int  redarax (int fd, int line, int elem, int nele, int  *buf)
{
 int i;  /* index */
 int  loc;	/* location of first byte */
 int len;	/* length of prefix */
 int cur_area = -1;
 char cerror[120];

 /*printf("in redarax line %d elem %d nele %d\n", line,elem,nele);*/ /*DEBUG*/
 for (i=0; i<=new_area; i++)
  {if(aracom[i].fd == fd) {cur_area=i; break;}}
 if(cur_area == -1)
  {printf ("file %d not opened \n",fd); return -1;}
 directptr = (void *)aracom[cur_area].dir;

 loc = (aracom[cur_area].line_len + aracom[cur_area].pref_len) * line +
    aracom[cur_area].pref_len +
    aracom[cur_area].elem_len * elem +
    directptr->data_loc;
 /*len = aracom[cur_area].line_len;*/
 len = aracom[cur_area].elem_len * nele;
 errno = 0;
 i = lseek(fd,loc,0);
 if (i < 0)
  {sprintf(cerror,"%s: redara: lseek error l1 errno= %d fdi: %d %d %d\n",
     varg[0],errno,fd,loc,i);
   perror(cerror); printf(cerror); return -1;}
 errno = 0;
 i = read (fd, buf, len);
 if (i != len && errno != 0)
  {sprintf(cerror,"%s: redara: read error r1 errno= %d fd: %d "
     " %d %d %d\n",varg[0],errno,fd,len,i,loc);
   printf(cerror); perror(cerror); return -1;}

 /* DEBUG */
 /*printf("%d\n", cur_area);*/
 /*printf("%08x %08x redara\n", aracom[cur_area].cin, aracom[cur_area].cout);*/
 /* DEBUG */

 return 0;
}
